<?php  //
       // 

/**
 * augsburg.lib.php - Contains functions for Augsburg's install of moodle
 *
 * @author Scott Krajewski
 * @version  $Id: augsburg.lib.php,v 1 2005/09/02 17:22:51 moodler Exp $
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package augsburg?
 * add a requireonce to your config.php to include this sitewide
 */



/**
 *  contacts students inactive in a course for X days
 *  with an academic alert message, uses log instead of students table
 *  $assistant is array of non-teachers who should know
 *  $debug is boolean for testing, if true only site admin and not teachers gets emailed
 *  it is assumed the username of assistants is unique as only the first record is retrieved
 * @uses 
 * @uses 
 * @param 
 * @todo 
 */ 
function contact_inactive_students_log ($id,$inactive = '5',$message,$assistant,$debug=false) {

global $CFG;


// contants and config vars
$adminuser = get_admin();
$course = get_record('course', 'id', $id);
// if debugging, use adminuser instead of real teachers
if ($debug) { $teachers = array ( $adminuser ); } else { $teachers = get_course_teachers($id); }
$timetoshowusers = $inactive * 24 * 60 * 60;
$timefrom = time()-$timetoshowusers;
$studentselect = "AND l.userid = u.id ";
$courseselect = "AND s.course = '".$id."' AND l.course = '".$id."' ";
$timeselect = "AND timeaccess > $timefrom";
$strftimedatetime = get_string("strftimedatetime");
$messagesubject = "[".$course->idnumber."] Student inactivity update";
$nostudents = false;
$users = array();

 
// get all enrolled students sorted by username
$allstudents = get_course_students($id,'u.username');

//get students who have been active and then remove them from the list
if ($students = get_records_sql("SELECT u.id, u.username, u.firstname, u.lastname, u.picture, u.lastaccess, u.idnumber,  max(l.time) as timeaccess
                                     FROM {$CFG->prefix}user u,
                                          {$CFG->prefix}user_students s,
                                          {$CFG->prefix}log l
                                     WHERE u.id = s.userid $studentselect $courseselect $timeselect 
                                     GROUP BY u.id")) {
    foreach ($students as $student) {
    	foreach ($allstudents as $onestudent) {
        		if ($student->id == $onestudent->id) { unset($allstudents[$student->id]); }  		
    	   	}    
    	}                                                                   
    }
    
// if there's anyone left, fill in the right timeaccess and fullname    
if ($allstudents) {
	// get proper timeaccess for the inactive students from logs
	foreach ($allstudents as $onestudent) {
		$onetime = get_record_sql("SELECT max(l.time) as timeaccess
									FROM {$CFG->prefix}user_students s,
									     {$CFG->prefix}log l
									WHERE {$onestudent->id} = s.userid AND {$onestudent->id} = l.userid 
									AND s.course = {$id} AND l.course = {$id}");
		$allstudents[$onestudent->id]->timeaccess = $onetime->timeaccess;
		$allstudents[$onestudent->id]->fullname = fullname($onestudent);
		}
	} else { $nostudents = true; }

// act based on if there's a student list
if ($nostudents) {
    // no students in the list, tell instructor
    $nostudentbody = "All students have been active in the past ".$inactive." day(s) in ".$course->fullname.".\n";
    
    // send message to each teacher
    foreach ($teachers as $teacher) {
    email_to_user($teacher,'',$messagesubject,$nostudentbody);
    }
    // if we passed an assistant list, loop through username list and email them
    if ($assistant) { 
    	foreach ($assistant as $helper) 
    	{
 		   	$assistantselect = 'username = \''.$helper.'\' AND deleted = 0';
        	$assistantuser = get_record_select('user',$assistantselect);
        	email_to_user($assistantuser,'',$messagesubject,$nostudentbody);
       		}
       	}
} else { // there is a list to send!
      $message .= "\n";
      foreach ($allstudents as $user) {
         if (($user->timeaccess == '0') OR ($user->timeaccess == null)) { $lasttime = 'never'; }
        else {
          $lasttime= userdate($user->timeaccess,'%a').",".userdate($user->timeaccess,$strftimedatetime);
           }

        $message .= "ID: ".$user->idnumber." Username : ".str_pad($user->username,9)." Name : ".$user->firstname." ".$user->lastname."\t Last access: ".$lasttime."\n";     
      }
  
  //send message to each teacher
  foreach ($teachers as $teacher) {
       email_to_user($teacher,'',$messagesubject,$message); 
       }
  // if we passed an assistant list, loop through username list and email them
  if ($assistant) { 
    	foreach ($assistant as $helper) 
    	{
 		   	$assistantselect = 'username = \''.$helper.'\' AND deleted = 0';
        	$assistantuser = get_record_select('user',$assistantselect);
        	email_to_user($assistantuser,'',$messagesubject,$message);
       		}
       	}
}

} //end function

function print_simple_box_augsburg($message, $align='', $width='', $color='', $padding=5, $class='generalbox', $id='') {
    print_simple_box_start_augsburg($align, $width, $color, $padding, $class, $id);
    echo stripslashes_safe($message);
    print_simple_box_end();
}

/* *
 * Print the top portion of a standard themed box with course idnumber in upper-right as backlink.
 *
 * in function display() 
 * in mod\resource\*\resource.class.php -- text, html
 * replace print_simple_box with print_simple_box_augsburg in the single case of non-pop-up
 * where we have else     /// not a popup at all
 *
 * @param string $align ?
 * @param string $width ?
 * @param string $color ?
 * @param int $padding ?
 * @param string $class ?
 * @todo Finish documenting this function
 */
 
function print_simple_box_start_augsburg($align='', $width='', $color='', $padding=5, $class='generalbox', $id='') {
	global $CFG,$course;

    if ($color) {
        $color = 'bgcolor="'. $color .'"';
    }
    if ($align) {
        $align = 'align="'. $align .'"';
    }
    if ($width) {
        $width = 'width="'. $width .'"';
    }
    if ($id) {
        $id = 'id="'. $id .'"';
    }
    echo "<table $align $width $id class=\"$class\" border=\"0\" cellpadding=\"$padding\" cellspacing=\"0\">".
         "<tr><td $color class=\"$class"."content\"><p align=\"right\"><a href=\"$CFG->wwwroot/course/view.php?id=".$course->id."\">Return to ".$course->shortname."</a></p>";
}


/*
* A course display without the description for the main page
*/

function print_course_aug($course, $width="100%") {

    global $CFG;

    static $enrol;

    if (empty($enrol)) {
        require_once("$CFG->dirroot/enrol/$CFG->enrol/enrol.php");
        $enrol = new enrolment_plugin;
    }

    print_simple_box_start("center", "$width", '', 5, "coursebox");

    $linkcss = $course->visible ? "" : " class=\"dimmed\" ";

    echo "<table width=\"100%\">";
    echo '<tr valign="top">';
    echo '<td valign="top" width="50%" class="info">';
    echo '<b><a title="'.get_string('entercourse').'"'.
         $linkcss.' href="'.$CFG->wwwroot.'/course/view.php?id='.$course->id.'">'.
         $course->fullname.'</a></b><br />';
    if ($teachers = get_course_teachers($course->id)) {
        echo "<span class=\"teachers\">\n";
        foreach ($teachers as $teacher) {
            if ($teacher->authority > 0) {
                if (!$teacher->role) {
                    $teacher->role = $course->teacher;
                }
                $fullname = fullname($teacher, isteacher($course->id)); // is the USER a teacher of that course
                echo $teacher->role.': <a href="'.$CFG->wwwroot.'/user/view.php?id='.$teacher->id.
                     '&amp;course='.SITEID.'">'.$fullname.'</a><br />';
            }
        }
        echo "</span>\n";
    }

    echo $enrol->get_access_icons($course);

    echo '</td></tr>';
    echo "</table>";

    print_simple_box_end();
}

/*
* Breaks main page into groups by Augsburg terms
* then shows courses that fall into that term
* because there is no field for term, it has to be derived from course idnumber
* in \index.php replace print_my_moodle with print_my_moodle_aug at line 156 or so
*/

function print_my_moodle_aug() {
/// Prints custom user information on the home page.
/// Over time this can include all sorts of information
/// Customized to do some Augsburg-desired formatting

    global $USER, $CFG;

    if (!isset($USER->id)) {
        error("It shouldn't be possible to see My Moodle without being logged in.");
    }

	$i = 0;
	$termlist = array("F","W","S","SU","O");
	$termname = array("Fall","Winter","Spring","Summer","Other");
	
	
	if ($coursecheck = get_my_courses($USER->id)) {
	/// make sure there are courses
	
	foreach ($termlist as $thisterm) // loop through terms
	{
		print_heading_block($termname[$i]);

		
    if ($courses = get_my_courses_bytime($USER->id,$termlist[$i],'idnumber ASC')) {
        foreach ($courses as $course) {
            if (!$course->category) {
                continue;
            }
            print_course_aug($course, "100%");
        }
		
	}
		$i++;
	
	}

    } else { // no courses, show categories
        if (count_records("course_categories") > 1) {
            print_simple_box_start("center", "100%", "#FFFFFF", 5, "categorybox");
            print_whole_category_list();
            print_simple_box_end();
        } else {
            print_courses(0, "100%");
        }
    }

	// always print search footer
            echo "<table width=\"100%\"><tr><td align=\"center\">";
            print_course_search("", false, "short");
            echo "</td><td align=\"center\">";
            print_single_button("$CFG->wwwroot/course/index.php", NULL, get_string("fulllistofcourses"), "get");
            echo "</td></tr></table>\n";
        


}

/*
* Grabs courses for term based on idnumber format
* Messy, but what can you do?
*/

function get_my_courses_bytime($userid, $term, $sort='visible DESC,sortorder ASC') {

    global $CFG;

    $course = array();
        
    if ($term == 'SU') {
    		$choice = 'AND '.$CFG->prefix.'course.idnumber LIKE \'%'.$term.'%\'';
    	}

       else if ($term =='O') {
       
       $choice = 'AND NOT ('.$CFG->prefix.'course.idnumber LIKE \'%F0%\''.
       ' OR '.$CFG->prefix.'course.idnumber LIKE \'%W0%\' '.
       ' OR '.$CFG->prefix.'course.idnumber LIKE \'%S0%\' '.
       ' OR '.$CFG->prefix.'course.idnumber LIKE \'%SU0%\' '.
       ' OR '.$CFG->prefix.'course.idnumber LIKE \'%SU2%\' )';
      
       
       }

    	else {
    
		    $choice = 'AND '.$CFG->prefix.'course.idnumber LIKE \'%'.$term.'0%\'';
    }

    if ($students = get_records_sql("SELECT ".$CFG->prefix."user_students.id,".$CFG->prefix."user_students.course
    								FROM ".$CFG->prefix."user_students,
    								".$CFG->prefix."course
    								WHERE ".$CFG->prefix."user_students.userid = ".$userid."
    								AND ".$CFG->prefix."user_students.course = ".$CFG->prefix."course.id "
    								.$choice)) {

        foreach ($students as $student) {
            $course[$student->course] = $student->course;
        }
    }
    if ($teachers = get_records_sql("SELECT ".$CFG->prefix."user_teachers.id,".$CFG->prefix."user_teachers.course
    								FROM ".$CFG->prefix."user_teachers,
    								".$CFG->prefix."course
    								WHERE ".$CFG->prefix."user_teachers.userid = ".$userid."
    								AND ".$CFG->prefix."user_teachers.course = ".$CFG->prefix."course.id "
    								.$choice)) {
    
    
        foreach ($teachers as $teacher) {
            $course[$teacher->course] = $teacher->course;
        }
    }
    if (empty($course)) {
        return $course;
    }

    $courseids = implode(',', $course);

    return get_records_list('course', 'id', $courseids, $sort);

//  The following is correct but VERY slow with large datasets
//
//    return get_records_sql("SELECT c.*
//                              FROM {$CFG->prefix}course c,
//                                   {$CFG->prefix}user_students s,
//                                   {$CFG->prefix}user_teachers t
//                             WHERE (s.userid = '$userid' AND s.course = c.id)
//                                OR (t.userid = '$userid' AND t.course = c.id)
//                             GROUP BY c.id
//                             ORDER BY $sort");
}

// print_heading_block_printable adds a little toggle to make the course page printable (no blocks)
// this is just a hack of print_heading_block from lib/weblib.php
// $id is the course id
// $printview is passed and updated to allow for toggle on and off by clicking
//
// to use, combine with the Augsburg course formats which call it

function print_heading_block_printable($heading, $class='', $id, &$printview) {

	global $CFG;

	if ($printview == 'yes') { $printview = 'no'; } else { $printview = 'yes'; }

    echo '<div class="headingblock header '.$class.'">'.stripslashes($heading).
    ' <div align="right"><a href="view.php?id='.$id.
    '&printview='.$printview.'">Printable view ';
  	if ($printview == 'yes') { echo 'on'; } else { echo 'off'; }  
    echo ' <img src="'.$CFG->wwwroot.'/pix/i/report.gif" alt="print" border="0" /></a></div></div>';
}

// forum_print_discussion_aug works with "Collect All Posts"
//  It displays a stripped-down version of the posts for printing only.
//  No replies, no ratings.  This is a copy of forum_print_discussion


function forum_print_discussion_aug($course, $forum, $discussion, $post, $mode, $canreply=NULL) {

    global $USER, $CFG;

    $ownpost = false;
    $reply = NULL;
    

    $ratings = NULL;
    $ratingsmenuused = false; // Never use ratings in this mode

    $post->forum = $forum->id;   // Add the forum id to the post object, later used by forum_print_post

    $post->subject = format_string($post->subject);

    if (forum_tp_can_track_forums($forum)) {
        if ($forumtracked = forum_tp_is_tracked($forum)) {
            $user_read_array = forum_tp_get_discussion_read_records($USER->id, $post->discussion);
        } else {
            $user_read_array = array();
        }
    } else {
        $forumtracked = false;
        $user_read_array = array();
    }

    if (forum_print_post($post, $course->id, $ownpost, $reply, $link=false, $ratings,
                         '', '', (!$forumtracked || isset($user_read_array[$post->id]) || forum_tp_is_post_old($post)))) {
        $ratingsmenuused = true;
    }

    switch ($mode) {
        case FORUM_MODE_FLATOLDEST :
        case FORUM_MODE_FLATNEWEST :
        default:
            if (forum_print_posts_flat($post->discussion, $course->id, $mode, $ratings, $reply,
                                       $user_read_array, $post->forum)) {
                $ratingsmenuused = true;
            }
            break;

        case FORUM_MODE_THREADED :
            if (forum_print_posts_threaded($post->id, $course->id, 0, $ratings, $reply,
                                           $user_read_array, $post->forum)) {
                $ratingsmenuused = true;
            }
            break;

        case FORUM_MODE_NESTED :
            if (forum_print_posts_nested($post->id, $course->id, $ratings, $reply,
                                         $user_read_array, $post->forum)) {
                $ratingsmenuused = true;
            }
            break;
    }

    if ($ratingsmenuused) {
        echo "<center><input type=\"submit\" value=\"".get_string("sendinratings", "forum")."\" />";
        if ($forum->scale < 0) {
            if ($scale = get_record("scale", "id", abs($forum->scale))) {
                print_scale_menu_helpbutton($course->id, $scale );
            }
        }
        echo "</center>";
        echo "</form>";
    }
}







?>
